﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using CoreGraphics;
using Foundation;
using Syncfusion.SfChart.iOS;
using UIKit;

namespace RealTimeData
{
    public partial class ViewController : UIViewController
    {

        SFChart chart;

        ObservableCollection<ChartModel> DataPoints { get; set; }

        protected ViewController(IntPtr handle) : base(handle)
        {
            // Note: this .ctor should not contain any initialization logic.
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();

            chart = new SFChart();
            DataPoints = new ObservableCollection<ChartModel>()
            {
				new ChartModel("January", 30),
				new ChartModel("February", 30),
				new ChartModel("March", 30),
				new ChartModel("April", 30),
				new ChartModel("June", 30),
            };

            chart.Frame = new CoreGraphics.CGRect(0, 0, View.Frame.Width, View.Frame.Height);

            SFDoughnutSeries series = new SFDoughnutSeries();
            series.ItemsSource = DataPoints;
            series.XBindingPath = "XValue";
            series.YBindingPath = "YValue";
            series.DataMarker.ShowLabel = true;
            series.DataMarker.LabelContent = SFChartLabelContent.YValue;
            series.DataMarker.LabelStyle.BackgroundColor = UIColor.Clear;
            series.DataMarker.LabelStyle.Color = UIColor.White;
            series.DataMarkerPosition = SFChartCircularSeriesLabelPosition.Inside;
            series.DataMarker.LabelStyle.LabelPosition = SFChartDataMarkerLabelPosition.Center;
            chart.Series.Add(series);

            chart.Delegate = new CustomDelegate();

            View.AddSubview(chart);
        }

        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();
        }
    }

    public class CustomDelegate : SFChartDelegate
    {
       
        public override UIView ViewForDataMarkerLabel(SFChart chart, NSString label, nint index, SFSeries series)
        {
	
            var dataPoints = (series.ItemsSource as IList<ChartModel>);

			UIView customView = new UIView();
			customView.Frame = new CGRect(0, 0, 80, 20);

			UILabel label1 = new UILabel();
			label1.Frame = new CGRect(3, 0, 60, 20);		    
            label1.Text = (NSString)(dataPoints[(int)index].YValue.ToString());
            label1.TextColor = UIColor.White;
			label1.Font = UIFont.FromName("Helvetica", 12f);
            label1.TextAlignment = UITextAlignment.Center;

			UILabel label2 = new UILabel();
			label2.Frame = new CGRect(3, 20, 60, 20);		
            label2.Text = (NSString)(dataPoints[(int)index].XValue);
			label2.Font = UIFont.FromName("Helvetica", 12f);
			label2.TextColor = UIColor.White;
            label2.TextAlignment = UITextAlignment.Center;

			customView.AddSubview(label1);
			customView.AddSubview(label2);
			return customView;
        }
    }

}


